#include "gbahearts.h"
// key stuff
u16 KeyChange;
u16 KeyData;
u32 UpdateKeys(void) {
	u16 nowkey=P1;
	
	nowkey = (nowkey^0xffff) & 0x03ff;
	KeyChange=(nowkey^KeyData)& nowkey; // keys that changed and are now down
	KeyData=nowkey;
	return KeyChange | KeyData<<16;
}
// returned keys are in the format:
//  binary: 0000 00ab cdef ghij  0000 00kl mnop qrst
// Pressed down: a=L,b=R,c=dn,d=up,e=lft,f=rt,g=st,h=sl,i=B,j=A
// change up->dn: k=L,l=R,m=dn,n=up,o=lft,p=rt,q=st,r=sl,s=B,t=A
u32 GetKeys(void) {
	return KeyChange | KeyData<<16;
}




