// menusystem header

struct keydata {
	u8 L,R,dn,up,lft,rt,st,sl,B,A;
};

struct MenuItm {
	u16 x;
	u16 y;
	u8 pitch;
	u8 textlen;
	u8 animtype;
	u8 selanimtype;
	char *text;
	struct keydata action,paramater;
};

struct MenuScrn {
	u8 numitems;
	u8 selitem;
	u8 sndcng,sndsel;
	// actions: 
	// 0- no action, 1-select item, 2-change menu, 3- play sound, 4- call routine
	struct keydata action,paramater;
	struct MenuItm * itemlist[];
};

struct MenuData {
	u8 nummenus,mainmenu;
	void ** functionlist;
	struct MenuScrn * menulist[];
};


// prototypes for menu system
void InitMenu(struct MenuData * mymenu);

void UpdateMenu(void);
