#include "gbahearts.h"

u32 shiftreg[4];

void InitRandom(u32 rndseed) {
	shiftreg[0]=rndseed+0xCF49E889;
	shiftreg[1]=rndseed+0x646609FC;
	shiftreg[2]=rndseed+0x7DB7E510;
	shiftreg[3]=rndseed+0x9762375A;
}

u32 RandomSingle(void) {
	u32 a,b;
	a=shiftreg[0]>>31;
	b=shiftreg[1]>>31;
	shiftreg[1]=(shiftreg[1]<<1)+a+0xE2AD2EFF;
	a=shiftreg[2]>>31;
	shiftreg[2]=(shiftreg[2]<<1)+b+0x8F270F59;
	b=shiftreg[3]>>30;
	shiftreg[3]=(shiftreg[3]<<1) + a+0x5CC0FA97;
	b=((b >> 1) + b) &1;
	shiftreg[0]=(shiftreg[0]<<1)+b+0xBEEB085E;

	return shiftreg[0]+shiftreg[1]+shiftreg[2]+shiftreg[3];
}

u32 Random(void) {
	u8 i;
	for(i=(GetKeys()&3)+1;i>0;i--) {
		RandomSingle();
	}
	return RandomSingle();
}
